<?php

namespace SIU\SQ\Lib\comandos;

use SIU\SQ\Lib\lib;
use SIU\SQ\Lib\constantes;
use Symfony\Component\Console;
use Symfony\Component\Console\Question\Question;

class crear_usuario_admin extends Console\Command\Command
{
	protected function configure()
    {
		$this
        ->setName('crear_usuario_admin')
        ->setDescription('Setea el nombre y el email del usuario administrador')
		->setHelp(sprintf(
				'%sUtilidades genericas%s',
				PHP_EOL,
				PHP_EOL
			));
    }

    protected function execute(Console\Input\InputInterface $input, Console\Output\OutputInterface $output)
    {
		$helper = $this->getHelper('question');
		
		$filtro = ['codigo' => constantes::PARAMETROS_SISTEMA_CODIGO_USUARIO_ADMIN];
		$parametro_usu_admin = lib::catalogo_daos()->parametros_sistema()->get_lista($filtro)[0];
		//si el usuario administrador ya esta seteado, pregunto si se desea sobrescribirlo
		if(!is_null($parametro_usu_admin['valor'])){
			$question_sobreescribir =
					new Question('El usuario administrador actual es "' . $parametro_usu_admin['valor'] . '". Desea sobrescribirlo? (s/n):');
			$question_sobreescribir->setValidator(function($resp) {
				if ($resp != 's' && $resp != 'n') {
					throw new \RuntimeException(
						'Debe ingresar "s" o "n"'
					);
				}
				return $resp;
			});
			$sobreescribe = $helper->ask($input, $output, $question_sobreescribir);
			if($sobreescribe == 'n'){
				return;//si responde n no hago nada
			}
		}
		$question_nombre = new Question('Ingrese el nombre del usuario administrador: ');
		$question_nombre->setValidator(function($nombre_ingresado) {
			if (is_null($nombre_ingresado)) {
				throw new \RuntimeException(
					'Debe ingresar el nombre del usuario administrador'
				);
			}
			return $nombre_ingresado;
		});
		$question_nombre->setMaxAttempts(2);
		$nombre = $helper->ask($input, $output, $question_nombre);
		
		$question_email = new Question('Ingrese el email del usuario administrador: ');
		$question_email->setValidator(function($email_ingresado) {
			if (is_null($email_ingresado)) {
				throw new \RuntimeException(
					'Debe ingresar el email del usuario administrador'
				);
			}
			//valido el email
			if(!filter_var($email_ingresado, FILTER_VALIDATE_EMAIL)){
				throw new \RuntimeException(
					'El email ingresado no es valido'
				);
			}
			return $email_ingresado;
		});
		$question_email->setMaxAttempts(2);
		$email = $helper->ask($input, $output, $question_email);
		
		try{
			lib::catalogo_procesos()->crear_usuario_admin($nombre,$email)->ejecutar();
			$output->write('Usuario creado con exito', TRUE);
		} catch (\Exception $ex) {
			$output->write('Error al crear el usuario', TRUE);
		}		
    }
			
}
