<?php

namespace SIU\SQ\Lib\comandos;

use SIU\SQ\Lib\errores\error;
use SIU\SQ\Lib\lib;
use Symfony\Component\Console;


class migrar_version extends Console\Command\Command
{
	protected function configure()
    {
		$this
        ->setName('migrar_version')
        ->setDescription('Inicia la migracion a una nueva version del sistema')
		->addArgument('version', null, 'Identificador de la version a migrar')
		->setHelp(sprintf(
				'%sUtilidades genericas%s',
				PHP_EOL,
				PHP_EOL
			));
    }

    protected function execute(Console\Input\InputInterface $input, Console\Output\OutputInterface $output)
    {
		$version = $input->getArgument("version");
		if($version AND !empty($version)){
			$proceso = lib::catalogo_procesos()->migrar_version($version);
			$proceso->ejecutar();
		}

		if(!$version OR empty($version)){
			$messages = "Ninguna version especificada. Para obtener ayuda: sq migrar_version --help";
			$output->write($messages, TRUE);
		}
    }
}
