<?php
namespace SIU\SQ\Lib\comandos;

use SIU\SQ\Lib\lib;
use Symfony\Component\Console;
use Symfony\Component\Console\Question\Question;

class reenviar_mensaje extends Console\Command\Command
{
	protected function configure()
    {
        $this
        ->setName('reenviar_mensaje')
        ->setDescription('Reenvia un mensaje especifico a Redis (RestHooks)')
        ->setDefinition(array(
			//new InputOption('path', null, null, 'Buscar todas las versiones'),			
        ))
        ->setHelp(sprintf(
				'%sUtilidades genericas%s',
				PHP_EOL, 
				PHP_EOL
            ));
    }

    protected function execute(Console\Input\InputInterface $input, Console\Output\OutputInterface $output)
    {
        $helper = $this->getHelper('question');

        $question_topicName = new Question('Ingrese el nombre del Tópico: ');
        $question_topicName->setValidator(function($topic_ingresado) {
            if (is_null($topic_ingresado)) {
                throw new \RuntimeException(
                    'Debe ingresar el nombre de un tópico'
                );
            }
            return $topic_ingresado;
        });
        $question_topicName->setMaxAttempts(2);
        $topicName = $helper->ask($input, $output, $question_topicName);

        $question_listenerName = new Question('Ingrese el nombre del listener: ');
        $question_listenerName->setValidator(function($listener_ingresado) {
            if (is_null($listener_ingresado)) {
                throw new \RuntimeException(
                    'Debe ingresar el nombre del listener'
                );
            }
            return $listener_ingresado;
        });
        $question_listenerName->setMaxAttempts(2);
        $listenerName = $helper->ask($input, $output, $question_listenerName);

        $question_messageId = new Question('Ingrese el id del mensaje: ');
        $question_messageId->setValidator(function($message_ingresado) {
            if (is_null($message_ingresado)) {
                throw new \RuntimeException(
                    'Debe ingresar el id del mensaje'
                );
            }
            return $message_ingresado;
        });
        $question_messageId->setMaxAttempts(2);
        $messageId = $helper->ask($input, $output, $question_messageId);

        try{
            $proceso = lib::catalogo_procesos()->reenviar_mensaje($topicName, $listenerName, $messageId);
            $proceso->ejecutar();
            $output->write('Mensaje reenviado.', TRUE);
        } catch (\Exception $ex) {
            $output->write('Error al reenviar el mensaje.', TRUE);
        }
    }
}