<?php
namespace SIU\SQ\Lib\daos;

use SIU\SQ\Lib\errores\error;

class dao
{
	protected $entorno;

	function __construct($entorno)
	{
		$this->entorno = $entorno;
	}

	/**
	 * @return entorno
	 */
	function entorno()
	{
		if(!isset($this->entorno)){
			throw new error("PROCESO - El entorno no esta cargado");
		}
		return $this->entorno;		
	}
	
	function quote($dato)
	{
		return $this->entorno()->db()->quote($dato);
	}
	
	/**
	 * Toma un string con formato json y retorna un array del mismo con los caracteres especiales bien decodificados
	 * @param string $json_string
	 * @return array
	 */
	function json_decode_caracteres_especiales($json_string)
	{
		$json_array = json_decode(utf8_encode($json_string), true);
		
		foreach (array_keys($json_array) as $id) {
			$elemento = $json_array[$id];
			if(is_array($elemento)){
				$json_array[$id] = $this->json_decode_caracteres_especiales(json_encode($elemento));
			} else {
				$elem = htmlentities($elemento, ENT_COMPAT, "ISO-8859-1");
				$resultado = html_entity_decode($elem, ENT_COMPAT, "ISO-8859-1");
				$json_array[$id] = utf8_decode($resultado);
			}
		}
		return $json_array;
	}
	
}
