<?php
namespace SIU\SQ\Lib\daos;

class dao_procesos extends dao
{
	function get($id)
	{
		$filtro['id'] = $id;
		$rs = $this->get_lista($filtro);
		if(count($rs) > 1){
			throw new error_negocio("dao_procesos: "
				. "La consulta devolvio mas de un registro.");
		}else{
			return (isset($rs[0])) ? $rs[0] : NULL;
		}
	}
	
	function get_lista($filtro = array(), $order_by = "", $limit = "")
	{
		$where = "";
		if(isset($filtro['id'])){
			$where .= " AND id = " . $this->quote($filtro['id']);
		}
		if(isset($filtro['codigo'])){
			$where .= " AND codigo = " . $this->quote($filtro['codigo']);
		}
		if(isset($filtro['descripcion'])){
			$where .= " AND descripcion = " . $this->quote($filtro['descripcion']);
		}
		$sql = "SELECT
					id,
					codigo,
					descripcion,
					id_tipo_proceso,
					hora,
					prioridad,
					modalidad,
					estado,
					estado_actualizado_en
				FROM
					procesos
				WHERE 1=1
					$where $order_by $limit;";
		return $this->entorno()->db()->consultar($sql);
	}
	
	function get_procesos_ejecuciones($filtro = array(), $order_by = "", $limit = "")
	{
		$where = "";
		if(isset($filtro['id'])){
			$where .= " AND id = " . $this->quote($filtro['id']);
		}
		if(isset($filtro['id_proceso'])){
			$where .= " AND id_proceso = " . $this->quote($filtro['id_proceso']);
		}
		$sql = "SELECT
					id,
					id_proceso,
					total_a_procesar,
					procesados_ok,
					procesados_error,
					iniciado_en,
					finalizado_en,
					id_proceso_ejecucion_estado
				FROM
					procesos_ejecuciones
				WHERE 1=1
					$where $order_by $limit;";
		return $this->entorno()->db()->consultar($sql);
	}
	
	function get_procesos_ejecuciones_log($id_proceso, $filtro = array(), $order_by = "ORDER BY id", $limit = "")
	{
		$where = "";
		if(isset($filtro['ocurrido_en'])){
			$where .= " AND ocurrido_en = " . $this->quote($filtro['ocurrido_en']);
		}
		if(isset($filtro['severidad'])){
			$where .= " AND severidad = " . $this->quote($filtro['severidad']);
		}
		$sql = "SELECT
					id,
					id_proceso_ejecucion,
					ocurrido_en,
					severidad,
					componente,
					texto
				FROM
					procesos_ejecuciones_log
				WHERE
					id_proceso_ejecucion = " . $this->quote($id_proceso) . "
					$where $order_by $limit;";
		return $this->entorno()->db()->consultar($sql);
	}
}
