<?php

namespace SIU\SQ\Lib\modelo;

use SIU\SQ\Lib\errores\error_negocio;

abstract class modelo
{

    protected $entorno;
    protected $datos;
    protected $es_alta;

    function __construct($entorno, $id = null)
    {
        $this->entorno = $entorno;
        $this->inicializar();
        if ($id !== null) {
            $this->cargar($id);
        }
    }

    // Metodo opcional
    protected function cargar($id)
    {

    }

    protected function validar_campos_obligatorios($datos, $campos_obligatorios, $prefijo_desc = '')
    {
        $error_obligatorios = false;
        foreach ($campos_obligatorios as $nombre_campo) {
            if (!in_array($nombre_campo, $datos, true)
                AND ( !isset($datos[$nombre_campo])
                    OR $datos[$nombre_campo] === NULL)) {
                $error_obligatorios[] = $nombre_campo;
            }
        }
        if ($error_obligatorios) {
            throw new error_negocio($prefijo_desc . ": Los siguientes campos son obligatorios: '"
                . implode("', '", $error_obligatorios) . "'.");
        }
    }

    protected function entorno()
    {
        return $this->entorno;
    }

    public function get_id()
    {
        return $this->datos['id'];
    }

    function es_alta()
    {
        return $this->es_alta;
    }

    function set_es_alta($es_alta)
    {
        $this->es_alta = $es_alta;
    }

    // Metodos obligatorios
    abstract protected function inicializar();

    abstract protected function validar();

    abstract public function guardar();
}
