<?php
namespace SIU\SQ\Lib\modelo;

use SIU\SQ\Lib\lib;
use SIU\SQ\Lib\db\sql;

class parametro_sistema extends modelo
{	
	function set_valor($valor)
	{
		$this->datos['valor'] = $valor;
	}
	
	protected function inicializar()
	{
		$this->datos['id'] = null;
		$this->datos['codigo'] = null;
		$this->datos['descripcion'] = null;
		$this->datos['categoria'] = null;
		$this->datos['valor'] = null;
		$this->datos['valor_default'] = null;
	}
	
	protected function cargar($id)
	{
		$this->datos = lib::catalogo_daos()->parametros_sistema()->get($id);
	}

	protected function validar()
	{
		// Controlar que esten cargados los datos basicos
		$campos_obligatorios = [
			'codigo',
			'descripcion',
			'categoria',
			'valor_default'
		];
		$this->validar_campos_obligatorios($this->datos, $campos_obligatorios, __CLASS__);
	}

	public function guardar()
	{
		$this->validar();
		if(is_null($this->datos['id'])) {
			$this->grabar_parametro();
		} else {
			$this->actualizar_parametro();
		}
	}

	function grabar_parametro()
	{
		$datos = [
			'codigo'		=> $this->datos['codigo'],
			'descripcion'	=> $this->datos['descripcion'],
			'categoria'		=> $this->datos['categoria'],
			'valor'			=> $this->datos['valor'],
			'valor_default'	=> $this->datos['valor_default']			
		];
		$sql = sql::sql_array_a_insert('parametros_sistema', $datos, $this->entorno()->db());
		$this->entorno()->db()->ejecutar($sql);
		// Consultar el valor de la secuencia generada
		$this->datos['id'] = $this->entorno()->db()->ultimo_insert_id("parametros_sistema_id_seq");
	}
	
	function actualizar_parametro()
	{
		$datos = [
			'codigo'		=> $this->datos['codigo'],
			'descripcion'	=> $this->datos['descripcion'],
			'categoria'		=> $this->datos['categoria'],
			'valor'			=> $this->datos['valor'],
			'valor_default'	=> $this->datos['valor_default']			
		];
		$where = ['id' => $this->datos['id']];
		$sql = sql::sql_array_a_update('parametros_sistema', $datos, $where, $this->entorno()->db());
		$this->entorno()->db()->ejecutar($sql);
	}

}
