<?php

namespace SIU\SQ\Lib\procesos;

use SIU\SQ\Lib\lib;
use SIU\SQ\Lib\constantes;
use SIU\SQ\Lib\errores\error_negocio;

class proceso_crear_usuario_admin extends proceso
{
	
	private $nombre;
	private $email;
	
	public function __construct($nombre, $email, $id_proceso, $entorno)
	{
		parent::__construct($id_proceso, $entorno);
		$this->set_email($email);
		$this->set_nombre($nombre);
	}
	
	function get_nombre()
	{
		return $this->nombre;
	}

	function get_email()
	{
		return $this->email;
	}

	function set_nombre($nombre)
	{
		$this->nombre = $nombre;
	}

	function set_email($email)
	{
		//valido el email
		if(!filter_var($email, FILTER_VALIDATE_EMAIL)){
			throw new error_negocio(
				'El email ingresado no es valido'
			);
		}
		$this->email = $email;
	}		

	public function ejecutar_especifico()
	{
		try{
			$filtro = ['codigo' => constantes::PARAMETROS_SISTEMA_CODIGO_USUARIO_ADMIN];
			$dao_parametros_sistema = lib::catalogo_daos()->parametros_sistema();
			$id = $dao_parametros_sistema->get_lista($filtro)[0]['id'];
			$parametro_usuario_admin = lib::catalogo_modelo()->parametro_sistema($id);
			$parametro_usuario_admin->set_valor($this->nombre);
			$parametro_usuario_admin->guardar();

			$filtro = ['codigo' => constantes::PARAMETROS_SISTEMA_CODIGO_EMAIL_ADMIN];
			$id = $dao_parametros_sistema->get_lista($filtro)[0]['id'];
			$parametro_email_admin = lib::catalogo_modelo()->parametro_sistema($id);
			$parametro_email_admin->set_valor($this->email);
			$parametro_email_admin->guardar();
			$this->finalizar_registro_ejecucion(self::ESTADO_OK);
		} catch (\Exception $ex) {
			$this->agregar_notificacion($ex->getMessage(),'error');
			$this->finalizar_registro_ejecucion(self::ESTADO_ERROR);
			throw $ex;
		}
	}

}
