<?php

namespace SIU\SQ\Lib\procesos;

use SIU\SQ\Lib\constantes;
use SIU\SQ\Lib\lib;

class proceso_iniciar_workers extends proceso
{
    function ejecutar_especifico()
    {
        try {
            $this->agregar_notificacion("Se inician los workers", 'info');
            lib::rest_hooks()->runWorkers();
        } catch (\Exception $e) {
            $this->agregar_notificacion($e->getMessage(), 'error');
            $this->finalizar_registro_ejecucion(proceso::ESTADO_ERROR);
            $this->entorno()->log()->err(__CLASS__ . ":" . $e->getTraceAsString());
        }
        $this->agregar_notificacion("Se detuvieron los workers", 'info');
        $this->finalizar_registro_ejecucion(proceso::ESTADO_INACTIVO);
    }
}