<?php
namespace SIU\SQ\Lib\procesos;

use SIU\SQ\Lib\lib;
use SIU\SQ\Lib\procesos;

class proceso_migrar_version extends proceso
{
	protected $RUTA_DDL = "../ddl/";
	protected $imprime_salida = true;
	protected $version = null;
	
	function __construct($version, $dir_instalacion=null, $imprime_salida = true, $entorno)
	{
		if(isset($_SERVER['SQ_DIR'])){
			$this->RUTA_DDL = $_SERVER['SQ_DIR']."/ddl/";
		}
		if($dir_instalacion){
			$this->RUTA_DDL = $dir_instalacion;
		}
		$this->imprime_salida = $imprime_salida;
		$this->version = $version;
		$this->set_entorno($entorno);
	}
	
	function ejecutar()
	{
		$this->ejecutar_especifico();
	}
	
	function ejecutar_especifico()
	{
		$this->iniciar('INICIANDO MIGRACION A VERSION: ' . $this->version );
		
		$version = lib::catalogo_modelo()->version();
		$version->migrar($this->version);
		
		$this->finalizar();
	}
	
	function iniciar($msg)
	{
		$params = $this->entorno()->db()->get_parametros();
		if($this->imprime_salida) echo "\n ------------------------------------------------------------------------";
		if($this->imprime_salida) echo "\n  " . $msg ;
		if($this->imprime_salida) echo "\n ------------------------------------------------------------------------";
	}
	
	function finalizar()
	{
		if($this->imprime_salida) echo "\n ------------------------------------------------------------------------\n";
	}
}
