<?php

namespace SIU\SQ\Lib\procesos;

use SIU\SQ\Lib\constantes;
use SIU\SQ\Lib\lib;

class proceso_reenviar_mensaje extends proceso
{
    private $topicName;
    private $listenerName;
    private $messageId;
    
    public function __construct($topicName, $listenerName, $messageId, $id_proceso, $entorno)
    {
        parent::__construct($id_proceso, $entorno);
        $this->topicName    = $topicName;
        $this->listenerName = $listenerName;
        $this->messageId    = $messageId;
    }
    
    function ejecutar_especifico()
    {
        try {
            $msg = "Iniciando reenvio de mensaje: " . $this->topicName . " - " . $this->listenerName . " - " . $this->messageId . "."; 
            $this->agregar_notificacion($msg, 'info');
            
            lib::rest_hooks()->getSender()->processRetry($this->topicName, $this->listenerName, $this->messageId);
            
            $this->finalizar_registro_ejecucion(proceso::ESTADO_OK);
        } catch (\Exception $e) {
            $this->agregar_notificacion($e->getMessage(), 'error');
            $this->finalizar_registro_ejecucion(proceso::ESTADO_ERROR);
            $this->entorno()->log()->err(__CLASS__ . ":" . $e->getTraceAsString());
        }
    }
}