<?php
namespace SIU\SQ\Lib\procesos;

use SIU\SQ\Lib\lib;
use SIU\SQ\Lib\errores\error;
use SIU\SQ\Lib\errores\error_db;
use SIU\SQ\Lib\errores\error_negocio;

class proceso_revertir_facturacion extends proceso
{
	protected $id_facturacion;
	protected $ids_servicios_instancias;
	
	function ejecutar_especifico()
	{
		try {
			
			$facturador = lib::catalogo_modelo()->facturador();
			$facturador->set_proceso($this);
			$facturador->set_id_facturacion($this->id_facturacion);
			$facturador->set_instancias_a_facturar($this->ids_servicios_instancias);
			$facturador->revertir();

			$this->agregar_notificacion("Ha finalizado el proceso de revertir la facturación", 'info');
			$this->finalizar_registro_ejecucion(proceso::ESTADO_OK);
		} catch (error_db $e) {
			$this->agregar_notificacion($e->getMessage(), 'error');
			$this->finalizar_registro_ejecucion(proceso::ESTADO_ERROR);
			throw $e;
		} catch (error_negocio $e) {
			$this->agregar_notificacion($e->getMessage(), 'error');
			$this->finalizar_registro_ejecucion(proceso::ESTADO_ERROR);
			throw $e;
		} catch (error $e) {
			$this->agregar_notificacion($e->getMessage(), 'error');
			$this->finalizar_registro_ejecucion(proceso::ESTADO_ERROR);
			throw $e;
		} catch (\Exception $e) {
			$this->agregar_notificacion($e->getMessage(), 'error');
			$this->finalizar_registro_ejecucion(proceso::ESTADO_ERROR);
			throw $e;
		}
	}
	
	public function set_instancias_a_facturar($id_servicios_instancias)
	{
		$this->ids_servicios_instancias = $id_servicios_instancias;
	}
	
	public function set_id_facturacion($id_facturacion)
	{
		$this->id_facturacion = $id_facturacion;
	}
}
