<?php

namespace SIU\SQ\Lib\procesos;

use SIU\SQ\Lib\errores\error;
use SIU\SQ\Lib\entorno\configurador;

class proceso_verificar_actividad_workers extends proceso
{
    function ejecutar_especifico()
    {
        try {
            $this->iniciar_workers();
            $this->finalizar_registro_ejecucion(proceso::ESTADO_OK);
        } catch (error $e) {
            $this->agregar_notificacion($e->getMessage(), 'error');
            $this->finalizar_registro_ejecucion(proceso::ESTADO_ERROR);
            $this->entorno()->log()->err(__CLASS__ . ":" . $e->getTraceAsString());
            throw $e;
        }
    }
    
    protected function iniciar_workers()
    {
        $config = new configurador();
        // Obtener los pid
        if(glob($config->get_config_dir() ."/*.pid")) {
            foreach (glob($config->get_config_dir() . "/*.pid") as $file) {
				$name = basename($file);
				$needle = strstr($name,'_',true);
				switch ($needle) {
					case 'scheduler' :
						$scheduler_pid = file_get_contents($file);
						$this->agregar_notificacion('Scheduler pid: ' . $scheduler_pid, 'info');
						break;
					case 'workers' :
						$workers_pid = file_get_contents($file);
						$this->agregar_notificacion('Worker pid: ' . $workers_pid, 'info');
						break;
				}
            }
        }else{
            $this->agregar_notificacion('No se pudo encontrar ningun archivo pid', 'error');
        }
        if ((!isset($scheduler_pid) OR !isset($workers_pid)) OR (!file_exists( "/proc/$scheduler_pid" ) OR !file_exists( "/proc/$workers_pid" ))){
            $this->agregar_notificacion('Se inician los workers', 'info');
            // Si no estan activos,reactivar el proceso "iniciar_workers" y dejarlo en segundo plano
            shell_exec($config->get_config_dir() . "/../bin/sq iniciar_workers > /dev/null 2>&1 &");
        }
    }
}