<?php

namespace SIU\SQ\Lib\sistemas_externos;

use SIU\SQ\Lib\constantes;
use SIU\SQ\Lib\errores\error_negocio;
use SIU\SQ\Lib\lib;

class catalogo extends \SIU\SQ\Lib\entorno\catalogo
{
	public function gestor_pago($id_medio_pago)
	{
        if ($id_medio_pago !== null) {
            switch ($id_medio_pago) {
                case constantes::MEDIO_PAGO_MERCADOPAGO:
                    return new mercado_pago($this->entorno);
                    break;
                case constantes::MEDIO_PAGO_PAYPERTIC:
                    return new paypertic($this->entorno);
                    break;
                default:
                    $msg = "El ID: '" . $id_medio_pago . "' de medio de pago no es valido para cargar un gestor de pago.";
                    lib::entorno()->log()->err(__METHOD__ . ": " . $msg);
                    throw new error_negocio($msg);
            }
        } else {
            $msg = "No esta seteado el ID del medio de pago.";
            lib::entorno()->log()->err(__METHOD__ . ": " . $msg);
            throw new error_negocio($msg);
        }
	}

    public function cliente()
    {
    }

    public function afip()
    {
    }
}
