<?php
namespace SIU\SQ\Lib\util;

class log implements \RDILog
{
	protected $id;
	protected $dir;
	protected $guardado=false;
	protected $activo = false;
	protected $debug = array();

	function  __construct($dir = false)
	{
		list($usec, $sec) = explode(" ", microtime());
		$this->id = date("Y.m.d__H.i__s.") . $usec;
		$this->dir = $dir;
		if ($dir !== false) {
			if(!is_dir($this->dir)){
				manejador_archivos::crear_arbol_directorios($this->dir);
			}		
		}
	}
	
	function set_activo($activo=true)
	{
		$this->activo = $activo;
	}

	function guardar()
	{
		if ($this->activo && !$this->guardado) {
			$path_log = $this->dir ."/". $this->id . '.log';
			try{
                $salida = '';
				foreach($this->debug as $debug) {
					$salida .= txt::titulo_seccion($debug[0]);
					$salida .= $debug[1] . "\n";
				}
                file_put_contents($path_log, $salida);
				$this->guardado = true;
			} catch (Exception $e) {
				die("Error generando el archivo de log: $path_log. " . $e->getMessage());
			}
		}
	}	
	
	//------------------------------------------------------------------------------
	//---- LOGGING
	//------------------------------------------------------------------------------
	
	function add_debug($etiqueta, $valor_a_dumpear, $tabla=false)
	{
        if (is_array($valor_a_dumpear)) {
            //$this->debug[] = array($etiqueta, print_r($valor_a_dumpear, true));
			if (!$tabla) {
				$this->debug[] = array($etiqueta, print_r($valor_a_dumpear,true));
			} else {
		        $this->debug[] = array($etiqueta, $this->array_txt($valor_a_dumpear));
			}
        } else {
			if(is_object($valor_a_dumpear)) {
	            $this->debug[] = array($etiqueta, var_export($valor_a_dumpear,true));			
			} else {
				$this->debug[] = array($etiqueta, $valor_a_dumpear);
			}
        }
	}

	function add_error($excepcion)
	{
        $clase = get_class($excepcion);
        $texto = $excepcion->getMessage();    
       	if ($excepcion instanceof \Exception) {
			$traza = $this->extraer_traza($excepcion);
		} else {
			$traza = 'No hay traza (excepcion mock)';
		}
        $log = "clase: $clase\nmensaje: $texto\ntraza: $traza";
        $this->debug[] = array($excepcion->getMessage(), $log);
	}

	static function extraer_traza(\Exception $excepcion)
	{
		//Solo muestra parametros en modo DEBUG
		if (strpos(get_class($excepcion),'Twig') !== false){
			return '';
		}
		$traza = $excepcion->getTrace();
		$traza[0]['file'] = $excepcion->getFile();
		$traza[0]['line'] = $excepcion->getLine();
		return self::formatear_traza($traza);
	}

	static function formatear_traza(& $pasos)
	{
    	$html = "[TRAZA]\n";
    	foreach ($pasos as $idpaso => $paso) {
			$clase = '';
			if (isset($paso['class'])) {
				$clase .= $paso['class'];
			}
			$html .= "\n---[ $idpaso ]-----------------------------------------\n\n";
			//Se obvia los pasos por esta clase
			if ($clase !== __CLASS__) {
				if (isset($paso['type']))
					$clase .= $paso['type'];
				$html .= "- function: $clase{$paso['function']}\n";
				if (isset($paso['file'])) {
					$html .= "- file: {$paso['file']}, linea {$paso['line']}\n";
				}
				if (! empty($paso['args'])) {
					$html .= "- param: \n";
					foreach ($paso['args'] as $idpar => $arg) {
						$html .= "\t $idpar: ";
						if (is_object($arg)) {
							$html .= 'object: '.get_class($arg).'';
						} else {
							if (!is_array($arg)) {
								if (strlen($arg)> 150) {
									$arg = substr($arg, 0, 150);
									$arg .= "..... ETC";
								}
							}
							$html .= print_r($arg, true);
						}
					}
				}
			}
    	}
    	return $html;
	}
}

?>