<?php
namespace SIU\SQ\Lib\util;


use SIU\SQ\Lib\errores\error_negocio;

class parametros_sistema
{
	protected $entorno;
	
	function __construct($entorno)
	{
		$this->entorno = $entorno;
		$this->cargar();
		
	}
	
	/**
	 * 
	 * @return entorno
	 */
	protected function entorno()
	{
		if(!isset($this->entorno)){
			throw new error("Parametros sistema - El entorno no esta cargado");
		}
		return $this->entorno;		
	}
	
	function cargar()
	{
		$sql = "SELECT id, codigo, descripcion, categoria, valor, valor_default 
				FROM parametros_sistema;";
		$parametros = $this->entorno()->db()->consultar($sql);
		foreach($parametros as $parametro){
			$this->datos[] = $parametro;
		}

		// Cargar parametros por tipo de servicio
        $sql = "SELECT 1 FROM   information_schema.tables
                WHERE  table_schema = 'public' AND    table_name = 'parametros_sistema_x_tipos_servicios';";
        $existen_parametros_x_tipo_servicio = $this->entorno()->db()->consultar($sql);
        if(!empty($existen_parametros_x_tipo_servicio)) {
            $sql = "SELECT id, id_parametro_sistema, id_tipo_servicio, valor 
				    FROM parametros_sistema_x_tipos_servicios;";
            $parametros_x_tipo_servicio = $this->entorno()->db()->consultar($sql);
            foreach($this->datos as $id => $valor) {
                foreach ($parametros_x_tipo_servicio as $parametro_x_tipo_servicio) {
                    if ($valor['id'] == $parametro_x_tipo_servicio['id_parametro_sistema']) {
                        $this->datos[$id]['tipos_servicios'][] = $parametro_x_tipo_servicio;
                    }
                }
            }
        }
	}
	
	function get_datos()
	{
		return $this->datos;
	}
	
	function get_valor($codigo_parametro)
	{
		$parametro = $this->get_parametro($codigo_parametro);
		return (!empty($parametro['valor'])) ? $parametro['valor'] : $parametro['valor_default'];
	}
	
	function get_parametro($codigo_parametro)
	{
		$parametro = null;
		foreach($this->datos as $param){
			if($codigo_parametro == $param['codigo']){
                $parametro = $param;
			}
		}
		if( !empty($parametro) ){
			return $parametro;
		}else{
			throw new error_negocio("El parámetro '" . $codigo_parametro . "' no existe.");
		}
	}
	
	function get_parametros_por_categoria($categoria)
	{
		$parametros = array();
		foreach($this->datos as $parametro){
			if($categoria == $parametro['categoria']){
				$parametros[] = $parametro;
			}
		}
		if( !empty($parametros) ){
			return $parametros;
		}else{
			throw new error_negocio("No exiten parámetros asociados a la categoría '" . $categoria . "'.");
		}
	}
}
